//+------------------------------------------------------------------+
//|                                          Multi BB Over Alert.mq4 |
//|                                                 Cutzpr@Forex-TSD |
//|                                                                  |
//+------------------------------------------------------------------+

#property indicator_chart_window
extern string Details="Enter TF in Minutes";
extern string Details1="Enter Period for each TF, 20 is default";
//
extern int BB_TF1=5;
extern int PERIOD1=20;
extern color TF1Color=Red;
extern bool TF1_Alert;
//
extern int BB_TF2=15;
extern int PERIOD2=20;
extern color TF2Color=Orange;
extern bool TF2_Alert;
//
extern int BB_TF3=60;
extern int PERIOD3=20;
extern color TF3Color=Brown;
extern bool TF3_Alert;
//
extern bool MultiTF_Alert=true;
extern bool ShowMA=false; // Enable if you would like to see the middle MA

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
{
   return(0);
}
int deinit()
{
   deleteObjects();return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
{
      double BB1H=iBands(NULL,BB_TF1,PERIOD1,2,0,PRICE_HIGH,MODE_UPPER,0);
      double BB1L=iBands(NULL,BB_TF1,PERIOD1,2,0,PRICE_LOW,MODE_LOWER,0);
      double BB2H=iBands(NULL,BB_TF2,PERIOD2,2,0,PRICE_HIGH,MODE_UPPER,0);
      double BB2L=iBands(NULL,BB_TF2,PERIOD2,2,0,PRICE_LOW,MODE_LOWER,0);
      double BB3H=iBands(NULL,BB_TF3,PERIOD3,2,0,PRICE_HIGH,MODE_UPPER,0);
      double BB3L=iBands(NULL,BB_TF3,PERIOD3,2,0,PRICE_LOW,MODE_LOWER,0);

      double BB1M=iBands(NULL,BB_TF1,PERIOD1,2,0,PRICE_MEDIAN,MODE_MAIN,0);
      double BB2M=iBands(NULL,BB_TF2,PERIOD2,2,0,PRICE_MEDIAN,MODE_MAIN,0);
      double BB3M=iBands(NULL,BB_TF3,PERIOD3,2,0,PRICE_MEDIAN,MODE_MAIN,0);
      
      //
      //
      //
      //
      //
      
      int adjust;
      switch(Period())
        {
          case 1:     adjust=1*15*60;     break;  // Adjust the last coordinate for the TF
          case 5:     adjust=5*15*60;     break;  
          case 15:    adjust=15*15*60;    break;
          case 30:    adjust=30*15*60;    break;
          case 60:    adjust=60*15*60;    break;
          case 240:   adjust=240*15*60;   break;
          case 1440:  adjust=1440*15*60;  break;
          case 10080: adjust=10080*15*60; break;
          case 43200: adjust=43200*15*60; break;
        }
   
      //
      //
      //
      //
      //
      
      
      createLine("1",BB1H,adjust,TF1Color);               createLabel("7" ,BB1H,adjust,TF1Color,"UTF1");
      createLine("2",BB1L,adjust,TF1Color);               createLabel("8" ,BB1L,adjust,TF1Color,"LTF1");
      createLine("3",BB2H,adjust,TF2Color);               createLabel("9" ,BB2H,adjust,TF2Color,"UTF2");
      createLine("4",BB2L,adjust,TF2Color);               createLabel("10",BB2L,adjust,TF2Color,"LTF2"); 
      createLine("5",BB3H,adjust,TF3Color,STYLE_SOLID,2); createLabel("11",BB3H,adjust,TF3Color,"UTF3");
      createLine("6",BB3L,adjust,TF3Color,STYLE_SOLID,2); createLabel("12",BB3L,adjust,TF3Color,"LTF3");
  
      if(ShowMA)
      {
         createLine("13",BB1M,adjust,TF1Color,STYLE_DASH,0); createLabel("16",BB1M,adjust,TF1Color,"TF1");
         createLine("14",BB2M,adjust,TF2Color,STYLE_DASH,0); createLabel("17",BB2M,adjust,TF2Color,"TF2");
         createLine("15",BB3M,adjust,TF3Color,STYLE_DASH,0); createLabel("18",BB3M,adjust,TF3Color,"TF3");
      }

      //
      //
      //
      //
      //
      
      if(TF1_Alert)
      {
         if(Ask>BB1H) Alert(Symbol()+" Price is Above TF1 Bollinger Band: Overbought");
         if(Bid<BB1L) Alert(Symbol()+" Price is Below TF1 Bollinger Band: Oversold");
      }
    
      if(TF2_Alert)
      {
         if(Ask>BB2H) Alert(Symbol()+" Price is Above TF2 Bollinger Band: Overbought");
         if(Bid<BB2L) Alert(Symbol()+" Price is Below TF2 Bollinger Band: Oversold");
      } 
      if(TF3_Alert)
      {
         if(Ask>BB3H) Alert(Symbol()+" Price is Above TF3 Bollinger Band: Overbought");
         if(Bid<BB3L) Alert(Symbol()+" Price is Below TF3 Bollinger Band: Oversold");
      }
      
        
      if(MultiTF_Alert)
      {
         if(Ask>BB1H && Ask>BB2H && Ask>BB3H) Alert(Symbol()+": Price is above all Bollinger Bands: Extremely OverBought");
         if(Bid<BB1L && Bid<BB2L && Bid<BB3L) Alert(Symbol()+": Price is below all Bollinger Bands: Extremely Oversold");
      }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void createLine(string name, double price, int adjust, color theColor, int style=STYLE_SOLID, int width=2)
{
   name = "Multi TF BB-"+name;
   if (ObjectFind(name)==-1)
      ObjectCreate(name,OBJ_TREND,0,Time[0],price,Time[0]+adjust,price);
         ObjectSet(name,OBJPROP_TIME1,Time[0]);
         ObjectSet(name,OBJPROP_TIME2,Time[0]+adjust);
         ObjectSet(name,OBJPROP_PRICE1,price);
         ObjectSet(name,OBJPROP_PRICE2,price);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_STYLE,style);
         ObjectSet(name,OBJPROP_WIDTH,width);
}
void createLabel(string name, double price, int adjust, color theColor, string text)
{
   name = "Multi TF BB-"+name;
   if (ObjectFind(name)==-1)
      ObjectCreate(name,OBJ_TEXT,0,Time[0],price);
         ObjectSet(name,OBJPROP_TIME1,Time[0]+adjust);
         ObjectSet(name,OBJPROP_PRICE1,price);
         ObjectSetText(name,text,6,"Arial",theColor);   
}
void deleteObjects()
{
   for(int i=ObjectsTotal()-1; i>=0; i--)
   {
      string name = ObjectName(i);
         if (StringSubstr(name,0,11) == "Multi TF BB") ObjectDelete(name);
   }         
}